Syncfusion AI Assistant

How can I help you?

Offline mode with EJ2 JavaScript DataManager

15 Apr 20264 minutes to read

In EJ2 JavaScript applications, remote data binding with DataManager typically sends a request to the server each time the executeQuery method is invoked. This repeated communication can increase latency and place additional load on the server.

To improve efficiency, DataManager provides an offline property. When enabled, all data is loaded during initialization, and subsequent query processing is handled on the client side. This eliminates unnecessary server calls, resulting in faster response times and reduced server overhead.

To enable offline mode in DataManager, set the offline property to true during initialization. This is demonstrated in the below code example.

var template = '<tr><td>${OrderID}</td><td>${CustomerID}</td><td>${EmployeeID}</td></tr>';

var compiledFunction = ej.base.compile(template);

const SERVICE_URL =  'https://services.odata.org/V4/Northwind/Northwind.svc/Orders/?$top=7';

var table = (document.getElementById('datatable'));

var dm = new ej.data.DataManager({ url: SERVICE_URL, adaptor: new ej.data.ODataV4Adaptor(), offline: true });

dm.ready.then((e) => {
        (e.result).forEach((data) => {
            table.appendChild(compiledFunction(data)[0]);
        });
  });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-grids/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/33.2.3/ej2-splitbuttons/styles/material.css" rel="stylesheet">

    
    
<script src="https://cdn.syncfusion.com/ej2/33.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
        <table id="datatable" class="e-table">
            <thead>
                <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th></tr>
            </thead>
            <tbody>
            </tbody>    
        </table>        
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

The loaded data will be cached in the json property of DataManager.

When to use Offline mode

Offline mode is most effective when:

  • The dataset is moderately sized and can be loaded during initialization.
  • Data does not change frequently, reducing the risk of stale results.
  • Client-side query processing provides a performance advantage.

When to avoid Offline mode

Offline mode should be avoided in scenarios such as:

  • Large datasets: Loading all records at once may cause performance issues in the browser.
  • Frequently changing data: Cached data may become outdated quickly.
  • Real-time requirements: Applications that depend on live or streaming data need server-side queries.
  • Sensitive data: Storing all records on the client side may expose information unnecessarily.

Syncfusion AI Assistant

How can I help you?

Working in offline mode with Vue DataManager

25 May 20246 minutes to read

In Vue applications, working with remote data binding using DataManager often involves sending requests to the server every time the executeQuery method is invoked. This process can result in unnecessary server calls, leading to increased latency and server load.

DataManager provides an offline property that allows you to load all data during initialization and perform query processing on the client-side. This approach eliminates the need to send requests to the server every time executeQuery is called, resulting in a more responsive and efficient data interaction experience.

To enable offline mode in DataManager, set the offline property to true during initialization. This is demonstrated in the below code example.

<template>
  <div id="app">
    <table class='e-table'>
      <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th><th>Ship Country</th></tr>
      <tr v-for="(item, index) in items" :key="index">
        <td>{{ item.OrderID }}</td>
        <td>{{ item.CustomerID }}</td>
        <td>{{ item.EmployeeID }}</td>
        <td>{{ item.ShipCountry }}</td>
      </tr>
    </table>   
  </div>
</template>

<script setup>
import { onMounted, ref } from "vue";
import { DataManager, Query, ODataAdaptor } from '@syncfusion/ej2-data';

const items = ref([]);

onMounted(() => {
  let SERVICE_URI = "https://services.syncfusion.com/vue/production/api/Orders";
  let dataManager = new DataManager({
    url: SERVICE_URI,
    adaptor: new ODataAdaptor(),
    offline: true
  });
  dataManager.executeQuery(new Query()).then((e) => {
    this.items = e.result;
  });
})
</script>

<style>
  .e-table {
    border: solid 1px #e0e0e0;
    border-collapse: collapse;
    font-family: Roboto;
  }

  .e-table td, .e-table th {
    border-style: solid;
    border-width: 1px 0 0;
    border-color: #e0e0e0;
    display: table-cell;
    font-size: 14px;
    line-height: 20px;
    overflow: hidden;
    padding: 8px 21px;
    vertical-align: middle;
    white-space: nowrap;
    width: auto;
  }
</style>
<template>
  <div id="app">
    <table class='e-table'>
      <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th><th>Ship Country</th></tr>
      <tr v-for="(item, index) in items" :key="index">
        <td>{{ item.OrderID }}</td>
        <td>{{ item.CustomerID }}</td>
        <td>{{ item.EmployeeID }}</td>
        <td>{{ item.ShipCountry }}</td>
      </tr>
    </table>   
  </div>
</template>

<script>
import { DataManager, Query, ODataAdaptor } from '@syncfusion/ej2-data';

export default {
  data() {
    return {
      items: [] 
    };
  },
  mounted() {
    let SERVICE_URI = "https://services.syncfusion.com/vue/production/api/Orders";
    let dataManager = new DataManager({
      url: SERVICE_URI,
      adaptor: new ODataAdaptor(),
      offline: true
    });
    dataManager.executeQuery(new Query()).then((e) => {
      this.items = e.result;
    });
  } 
}
</script>

<style>
  .e-table {
    border: solid 1px #e0e0e0;
    border-collapse: collapse;
    font-family: Roboto;
  }

  .e-table td, .e-table th {
    border-style: solid;
    border-width: 1px 0 0;
    border-color: #e0e0e0;
    display: table-cell;
    font-size: 14px;
    line-height: 20px;
    overflow: hidden;
    padding: 8px 21px;
    vertical-align: middle;
    white-space: nowrap;
    width: auto;
  }
</style>

The loaded data will be cached in the json property of DataManager.

Syncfusion AI Assistant

How can I help you?

Offline mode with Angular DataManager

15 Apr 20264 minutes to read

In Angular applications, remote data binding with DataManager typically sends a request to the server each time the executeQuery method is invoked. This repeated communication can increase latency and place additional load on the server.

To improve efficiency, DataManager provides an offline property. When enabled, all data is loaded during initialization, and subsequent query processing is handled on the client side. This eliminates unnecessary server calls, resulting in faster response times and reduced server overhead.

To enable offline mode in DataManager, set the offline property to true during initialization. This is demonstrated in the below code example.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { CommonModule } from '@angular/common';
import { Component, OnInit } from '@angular/core';
import { DataManager, Query, ODataV4Adaptor, ReturnOption } from '@syncfusion/ej2-data';

const SERVICE_URL = 'https://services.odata.org/V4/Northwind/Northwind.svc/Orders/';
@Component({
    imports: [CommonModule],
    standalone: true,
    selector: 'app-root',
    templateUrl: './app.template.html',
    styles: [`
        .e-table {
            border: solid 1px #e0e0e0;
            border-collapse: collapse;
            font-family: Roboto;
        }

        .e-table td, .e-table th {
            border-style: solid;
            border-width: 1px 0 0;
            border-color: #e0e0e0;
            display: table-cell;
            font-size: 14px;
            line-height: 20px;
            overflow: hidden;
            padding: 8px 21px;
            vertical-align: middle;
            white-space: nowrap;
            width: auto;
        }
        `
    ]
})
export class AppComponent implements OnInit {

    public items: object[] | any = [];

    public ngOnInit(): void {
        new DataManager({ url: SERVICE_URL, adaptor: new ODataV4Adaptor(), offline: true})
        .executeQuery(new Query().take(8)).then((e: ReturnOption) => this.items = e.result as object[]).catch((e) => true);
    }
}
<table class='e-table'>
    <tr><th>Order ID</th><th>Customer ID</th><th>Employee ID</th></tr>
    <tr *ngFor="let item of items">
        <td>{{item.OrderID}}</td><td>{{item.CustomerID}}</td><td>{{item.EmployeeID}}</td>
    </tr>
</table>
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The loaded data will be cached in the json property of DataManager.

When to use Offline mode

Offline mode is most effective when:

  • The dataset is moderately sized and can be loaded during initialization.
  • Data does not change frequently, reducing the risk of stale results.
  • Client-side query processing provides a performance advantage.

When to avoid Offline mode

Offline mode should be avoided in scenarios such as:

  • Large datasets: Loading all records at once may cause performance issues in the browser.
  • Frequently changing data: Cached data may become outdated quickly.
  • Real-time requirements: Applications that depend on live or streaming data need server-side queries.
  • Sensitive data: Storing all records on the client side may expose information unnecessarily.

Syncfusion AI Assistant

How can I help you?

Offline mode with React DataManager

20 Feb 20267 minutes to read

In React applications, remote data binding with DataManager typically sends a request to the server each time the executeQuery method is invoked. This repeated communication can increase latency and place additional load on the server.

To improve efficiency, DataManager provides an offline property. When enabled, all data is loaded during initialization, and subsequent query processing is handled on the client side. This eliminates unnecessary server calls, resulting in faster response times and reduced server overhead.

To enable offline mode in DataManager, set the offline property to true during initialization. This is demonstrated in the below code example.

import React, { useEffect, useState } from 'react';
import { getValue } from '@syncfusion/ej2-base';
import { DataManager, ODataV4Adaptor, Query } from '@syncfusion/ej2-data';
import { Row } from './rowTemplate';

const SERVICE_URL = 'https://services.odata.org/V4/Northwind/Northwind.svc/Orders/';

const App = () => {
  const [items, setItems] = useState([]);

  useEffect(() => {
    const dataManager = new DataManager(
      {
        url: SERVICE_URL,
        adaptor: new ODataV4Adaptor(),
        offline: true
      },
      new Query().take(8)
    );

    dataManager.ready.then((e) => {
      const rows = e.result.map((row) => (
        <Row key={row.OrderID} {...row} />
      ));
      setItems(rows);
    });
  }, []);

  return (
    <table id="datatable" className="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody>{getValue('items', { items })}</tbody>
    </table>
  );
};

export default App;
import * as React from 'react';
import { useEffect, useState } from 'react';
import { getValue } from '@syncfusion/ej2-base';
import { DataManager, ODataV4Adaptor, Query, ReturnOption } from '@syncfusion/ej2-data';
import { IOrders } from './orders';
import { Row } from './rowTemplate';

const SERVICE_URL: string = 'https://services.odata.org/V4/Northwind/Northwind.svc/Orders/';

const App: React.FC = () => {
  const [items, setItems] = useState<JSX.Element[]>([]);

  useEffect(() => {
    const dataManager: DataManager = new DataManager(
      {
        url: SERVICE_URL,
        adaptor: new ODataV4Adaptor(),
        offline: true
      },
      new Query().take(8)
    );

    dataManager.ready.then((e: ReturnOption) => {
      const rows = (e.result as IOrders[]).map((row: IOrders) => (
        <Row key={row.OrderID} {...row} />
      ));
      setItems(rows);
    });
  }, []);

  return (
    <table id="datatable" className="e-table">
      <thead>
        <tr>
          <th>Order ID</th>
          <th>Customer ID</th>
          <th>Employee ID</th>
        </tr>
      </thead>
      <tbody>{getValue('items', { items })}</tbody>
    </table>
  );
};

export default App;
export interface IOrders {
    OrderID: number; 
    EmployeeID: number; 
    CustomerID: string; 
    Order_Details: object[]; 
}
import React from 'react';

export const Row = (props) => {
  return (
    <tr>
      <td>{props.OrderID}</td>
      <td>{props.CustomerID}</td>
      <td>{props.EmployeeID}</td>
    </tr>
  );
};
import * as React from 'react';
import { IOrders } from './orders';

export const Row: React.FC<IOrders> = (props) => {
  return (
    <tr>
      <td>{props.OrderID}</td>
      <td>{props.CustomerID}</td>
      <td>{props.EmployeeID}</td>
    </tr>
  );
};

The loaded data will be cached in the json property of DataManager.

When to use Offline mode

Offline mode is most effective when:

  • The dataset is moderately sized and can be loaded during initialization.
  • Data does not change frequently, reducing the risk of stale results.
  • Client-side query processing provides a performance advantage.

When to avoid Offline mode

Offline mode should be avoided in scenarios such as:

  • Large datasets: Loading all records at once may cause performance issues in the browser.
  • Frequently changing data: Cached data may become outdated quickly.
  • Real-time requirements: Applications that depend on live or streaming data need server-side queries.
  • Sensitive data: Storing all records on the client side may expose information unnecessarily.